from Products.slideshowfolder.config import *
from Products.CMFCore.utils import getToolByName

def install(portal):
    """Our install process is to importing our Generic Setup profile and
    install CMFonFive."""
    qit = getToolByName(portal, 'portal_quickinstaller')
    products_to_install = ["CMFonFive",]
    ids = [ x['id'] for x in qit.listInstallableProducts(skipInstalled=1) ]
    for product in products_to_install:
        if product in ids:
            qit.installProduct(product)


    setup_tool = getToolByName(portal, 'portal_setup')
    original_context = setup_tool.getImportContextID()
    setup_tool.setImportContext('profile-slideshowfolder:default')
    feedback = setup_tool.runAllImportSteps()
    setup_tool.setImportContext(original_context)
    feedback = feedback['messages']
    gs_output = ["%s: %s" % (k, feedback[k]) for k in feedback.keys() if feedback[k]]
    return """Ran WhatCounts Signup import steps.: 
    %s""" % "\n".join(gs_output)

def uninstall(portal):
    """CSS, js, actions, and skin registration are all automatically undone for us.
        We just need to remove our skin layers
    """
    skinstool = getToolByName(portal, 'portal_skins')
    for skinName in skinstool.getSkinSelections():
        path = skinstool.getSkinPath(skinName)
        path = [i.strip() for i in  path.split(',')]
        prev = len(path)
        for old_skin in ('slideshowfolder', 'slideshowjavascript'):
            if old_skin in path:
                path.remove(old_skin)
        if prev != len(path):
            path = ','.join(path)
            skinstool.addSkinSelection(skinName, path)
    return "Removed slideshow skin layers"
    